from numpy import *
import random
import matplotlib.pyplot as plt
import math
import networkx as nx
#Desviacion estandar 
def desvi(lista,prom):
	z=0.
		
	for j in range(len(lista)):
		z=z+(lista[j]-prom)**2
	
	return (z/float(len(lista)*(len(lista)-1.)))**.5

	



#Iguala dominio de histogramas
def igualdimDP(K,P):
	mAx=int(max(max(s) for s in K))
	mIn=int(min(min(s)for s in K))
	k=range(mIn,mAx+1)
	PP=[]
	for i in range(len(P)):
		PP.append([0]*len(k))
	for i in k:
		for j in range(len(P)):
			if i in K[j]:
				PP[j][i-mIn]=P[j][K[j].index(i)]
	return k, PP
		
#Distribucion de grado
def hgrado(grados):
	k,ng=[],[]
	for i in grados:
		if i not in k:
			k.append(float(i))
	i=0
	while (i<len(k)-1):
		if (i<len(k)):
			ng.append(grados.index(k[i+1])-grados.index(k[i]))
		i=i+1	

	ng.append(len(grados)-grados.index(k[-1]))	
	return k, list(array(ng)*(1./float(len(grados))))

##Crea la red de visibilidad horizontal
def vishor(t,M):
	G=nx.Graph()
	G.add_nodes_from(t)
	for i in range(0,len(M)-1):
		G.add_edge(i,i+1)
	for i in range(0,len(M)-2):
		j=i+1 
		while (M[j] <M[i] ) and (j<len(M)-1): 
			j=j+1
			Mmax=max(M[i+1:j])
			if (M[j]>Mmax):
				G.add_edge(i,j)
		G.add_edge(i,j)
		if (max(M[i:j])>M[j]):
			G.remove_edge(i,j)
	G.remove_node(len(M)-1)
	return G

#Crea la red de visibilidad natural
def visnat(t,M):
	G=nx.Graph()
	G.add_nodes_from(t)
	for i in range(0,len(M)-1):
		G.add_edge(i,i+1)
	for i in range(0,len(M)-2):
		pm=p=(M[i]-M[i+1])/(t[i]-t[i+1])
		for j in range(i+2,len(M)):
			p=(M[i]-M[j])/(t[i]-t[j])
			if(p>pm):	
				G.add_edge(i,j)		
				pm=p
	return G





#######################################################################
#######################EMPIEZA PROGRAMA################################
#vis.nat

KTn=[]			#grados de los promedios de distribuciones de una temp.
DPTn=[]			#dist. de prob promediada de las series a una temp.
kpromTn=[]		#promedio de grados promedio
CCTn=[]			#promedio de transitivad
ASPLTn=[]		#promedios de aspl  

dKTn=[]			
dDPTn=[]		
dkpromTn=[]		
dCCTn=[]			
dASPLTn=[]
#vis.hor
KTh=[]			#grados de los promedios de distribuciones de una temp.
DPTh=[]			#dist. de prob promediada de las series a una temp.
kpromTh=[]		#promedio de grados promedio
CCTh=[]			#promedio de transitivad
ASPLTh=[]		#promedios de aspl 

dKTh=[]			
dDPTh=[]		
dkpromTh=[]		
dCCTh=[]			
dASPLTh=[]


#archi=open('nathor333'+'.txt','a')
#archi.write("temp"+"\t"+"Kn"+"\t"+"dKn"+"\t"+"Cn"+"\t"+"dCn"+"\t"+"Ln"+"\t"+"dLn"+"\t"+"Kh"+"\t"+"dKh"+"\t"+"Ch"+"\t"+"dCh"+"\t"+"Lh"+"\t"+"dLh"+"\n" )
#archi.close
for T in range(287,317,5):
	print T
#vis.nat
	DPn=[]                  #Dist. de Prob de cada serie nat
	KPn=[]			#Grado de cada serie nat
	kpromn=[]               #grado promedio de cada serie
	ASPLn=[]		#aspl de cada serie nat
	CCn=[]                  #transitividad de cada serie nat
	#DPTn=[]		
#vis.hor
	DPh=[]                  #Dist. de Prob de cada serie nat
	KPh=[]			#Grado de cada serie nat
	kpromh=[]               #grado promedio de cada serie
	ASPLh=[]		#aspl de cada serie nat
	CCh=[]                  #transitividad de cada serie nat
	DPTh=[]		
#vis.hor.dir

	#####################
	
	KTh=[]			#grados de los promedios de distribuciones de una temp.

	KTn=[]			#grados de los promedios de distribuciones de una temp.
	DPTn=[]	


	for ite in range(100):
		print ite 

		M=[]
		t=[]
		s='\1 '
		[x for x in s.split('\n')]
		with open(str(T)+'_'+str(ite)+'.txt','r') as f:
		 	data=[x.strip().split('\t') for x in f]
		for j in range(999,len(data)):	
			ti=float(data[j][0])-999
			t.append(ti)
			M.append(float(data[j][1]))
				#Natural
		Gn=visnat(t,M)
		gradosn=sorted(nx.degree(Gn).values())
		kp=0.
		for i in range(len(gradosn)):
			kp=kp+gradosn[i]
		kpromn.append(float(kp)/len(gradosn))
		ASPLn.append(nx.average_shortest_path_length(Gn))
		CCn.append(nx.average_clustering(Gn))
		Knat,Pnat=hgrado(gradosn)
		DPn.append(Pnat)
		KPn.append(Knat)
		#Horizontal"""
		Gh=vishor(t,M)
		gradosh=sorted(nx.degree(Gh).values())

		kph=0.
		for i in range(len(gradosh)):
			kph=kph+gradosh[i]
		kpromh.append(float(kph)/len(gradosh))
		ASPLh.append(nx.average_shortest_path_length(Gh))
		CCh.append(nx.average_clustering(Gh))
		Khor,Phor=hgrado(gradosh)
		DPh.append(Phor)
		KPh.append(Khor)



	
	Kh,Ph=igualdimDP(KPh,DPh)
	Kn,Pn=igualdimDP(KPn,DPn)

	for i in range(len(Kh)):
		kt=0
		for j in range(len(Ph)):
			kt=kt+Ph[j][i]
		DPTh.append(kt/float(len(Ph)))
	KTh=Kh
	kph=0.
	asplh=0
	cch=0
	for i in range(len(kpromh)):
		kph=kph+kpromh[i]
		asplh=asplh+ASPLh[i]
		cch=cch+CCh[i]
	kph=kph/float(len(kpromh))
	asplh=asplh/float(len(kpromh))
	cch=cch/float(len(kpromh))

	dkpromTh=desvi(kpromh,kph)
	dASPLTh=desvi(ASPLh,asplh)
	dCCTh=desvi(CCh,cch)	
	for i in range(len(Kn)):
		kt=0.              
		for j in range(len(Pn)): ##100
			kt=kt+Pn[j][i]
		
		DPTn.append(kt/float(len(Pn)))
	KTn=Kn
	kpn=0.
	aspln=0
	ccn=0.

	for i in range(len(kpromn)):
		kpn=kpn+kpromn[i]
		aspln=aspln+ ASPLn[i]
		ccn=ccn+CCn[i]
	kpn=kpn/float(len(kpromn))
	aspln=aspln/float(len(kpromn))
	ccn=ccn/float(len(kpromn))

	dkpn=desvi(kpromn,kpn)
	dASPLTn=desvi(ASPLn,aspln)
	dCCTn=desvi(CCn,ccn)
	archi=open('nathor333'+'.txt','a')
	archi.write(str(T/100.)+"\t"+str(kpn)+"\t"+str(dkpn)+"\t"+str(ccn)+"\t"+str(dCCTn)+"\t"+str(aspln)+"\t"+str(dASPLTn)+"\t"+str(kph)+"\t"+str(dkpromTh)+"\t"+str(cch)+"\t"+str(dCCTh)+"\t"+str(asplh)+"\t"+str(dASPLTh)+"\n")
	"""
	if KTn[0]==1:
		KTn.pop(0)
		DPTn.pop(0)
	if KTh[0]==1:
		KTh.pop(0)
		DPTh.pop(0)
	
	plt.figure(1)
	plt.semilogy()
	#plt.semilogx()
	if (T==152):
		plt.plot(KTn,DPTn,c=str((312-T)/170.),label='T<Tc')
	if (T<227):
		plt.plot(KTn,DPTn,c=str((312-T)/170.))
		plt.scatter(KTn,DPTn,c=str((312-T)/170.),marker='D')
	elif (T==227):
		ktn,dptn=KTn,DPTn

	else:
		plt.plot(KTn,DPTn,c=str((312-T)/170.))
		plt.scatter(KTn,DPTn,c=str((312-T)/170.),marker='o')
	if (T==312):
		plt.plot(KTn,DPTn,c=str((312-T)/170.),label='T>Tc')

	plt.figure(2)
	plt.semilogy()
	#plt.semilogx()
	if (T==152):
		plt.plot(KTh,DPTh,c=str((312-T)/170.),label='T<Tc')
	if (T<227):
		plt.plot(KTh,DPTh,c=str((312-T)/170.))
		plt.scatter(KTh,DPTh,c=str((312-T)/170.),marker='D')
	elif (T==227):
		kth,dpth=KTh,DPTh
	else:
		plt.plot(KTh,DPTh,c=str((312-T)/170.))
		plt.scatter(KTh,DPTh,c=str((312-T)/170.),marker='o')
	if (T==312):
		plt.plot(KTh,DPTh,c=str((312-T)/170.),label='T>Tc')"""

	
"""
###Distribuciones de grado
plt.figure(2)

plt.plot(kth,dpth,c='r')
plt.title('Distribuciones de grado VH')
plt.ylabel('P(k)')
plt.xlabel('k')
plt.legend()


plt.figure(1)

plt.plot(ktn,dptn,c='r')
plt.title('Distribuciones de grado VN')
plt.ylabel('P(k)')
plt.xlabel('k')
plt.legend()


plt.show()
"""
archi.close



