from numpy import *
import random
import matplotlib.pyplot as plt
import math
import networkx as nx
"""def vishor(t,M):
	G=nx.Graph()
	G.add_nodes_from(t)
	for i in range(0,len(M)-1):
		G.add_edge(i,i+1)
	for i in range(0,len(M)-2):
		j=i+1 
		while (M[j] <M[i] ) and (j<len(M)-1): 
			j=j+1
			Mmax=max(M[i+1:j])
			if (M[j]>Mmax):
				G.add_edge(i,j)
		G.add_edge(i,j)
		if (max(M[i:j])>M[j]):
			G.remove_edge(i,j)
	G.remove_node(len(M)-1)
	return G
def visnat(t,M):
	G=nx.Graph()
	G.add_nodes_from(t)
	for i in range(0,len(M)-1):
		G.add_edge(i,i+1)
	for i in range(0,len(M)-2):
		pm=p=(M[i]-M[i+1])/(t[i]-t[i+1])
		for j in range(i+2,len(M)):
			p=(M[i]-M[j])/(t[i]-t[j])
			if(p>pm):	
				G.add_edge(i,j)		
				pm=p
	return G

C1h=[]
L1h=[]
K1n=[]
C1n=[]
L1n=[]
K1h=[]
print arange(1.42,3.17,.05)
for T in range(142,317,5):
	print T
	M=[]
	t=[]
	s='\1 '
	[x for x in s.split('\n')]
	with open(str(T)+'.txt','r') as f:
	 	data=[x.strip().split('\t') for x in f]
	for j in range(999,len(data)):	
		ti=float(data[j][0])-999
		t.append(ti)
		M.append(float(data[j][1]))
	Gn=visnat(t,M)
	Gh=vishor(t,M)
	gradosn=sorted(nx.degree(Gn).values())
	gradosh=sorted(nx.degree(Gh).values())
	kp=0.
	for i in range(len(gradosn)):
		kp=kp+gradosn[i]
	K1n.append(float(kp)/len(gradosn))
	L1n.append(nx.average_shortest_path_length(Gn))
	C1n.append(nx.average_clustering(Gn))
	kph=0.
	for i in range(len(gradosh)):
		kph=kph+gradosh[i]
	K1h.append(float(kph)/len(gradosh))
	L1h.append(nx.average_shortest_path_length(Gh))
	C1h.append(nx.average_clustering(Gh))

"""


T=[]
Kn=[]
dKn=[]
Cn =[]
dCn=[]
Ln=[]
dLn=[]
Kh=[]
dKh=[]
Ch=[]
dCh=[]
Lh=[]
dLh=[]

s='\1 '
[x for x in s.split('\n')]
with open('nathor.txt','r') as f:
 	data=[x.strip().split('\t') for x in f]
for j in range(1,len(data)):	
	
	T.append(float(data[j][0]))
	Kn.append(float(data[j][1]))
	dKn.append(float(data[j][2]))
	Cn.append(float(data[j][3]))
	dCn.append(float(data[j][4]))
	Ln.append(float(data[j][5]))
	dLn.append(float(data[j][6]))
	Kh.append(float(data[j][7]))
	dKh.append(float(data[j][8]))
	Ch.append(float(data[j][9]))
	dCh.append(float(data[j][10]))
	Lh.append(float(data[j][11]))
	dLh.append(float(data[j][12]))
plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Grado promedio en AVN del modelo de Ising')
plt.ylabel(r'$\langle k(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Kn)
plt.errorbar(T,Kn,yerr=dKn,c='k')
plt.show()

plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Transitividad promedioen AVN del modelo de Ising')
plt.ylabel(r'$\langle C(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Cn)
plt.errorbar(T,Cn,yerr=dCn,c='k')
plt.show()

plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Longitud de camino mas corto promedio en AVN del modelo de Ising')
plt.ylabel(r'$\langle d(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Ln)
plt.errorbar(T,Ln,yerr=dLn,c='k')
plt.show()

plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Grado promedio en AVh del modelo de Ising')
plt.ylabel(r'$\langle k(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Kh)
plt.errorbar(T,Kh,yerr=dKh,c='k')
plt.show()

plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Transitividad promedio en AVH del modelo de Ising')
plt.ylabel(r'$\langle C(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Ch)
plt.errorbar(T,Ch,yerr=dCh,c='k')
plt.show()

plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Longitud de camino mas corto promedio en AVH del modelo de Ising')
plt.ylabel(r'$\langle d(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Lh)
plt.errorbar(T,Lh,yerr=dLh,c='k')
plt.show()
