from numpy import *
import random
import matplotlib.pyplot as plt
import math
import networkx as nx


T=[]
Cs=[]
dCs=[]
lc =[]
dlc=[]


s='\1 '
[x for x in s.split('\n')]
with open('isinghorcomprom.txt','r') as f:
 	data=[x.strip().split('\t') for x in f]
for j in range(0,len(data)):	
	
	T.append(float(data[j][0]))
	Cs.append(float(data[j][1]))
	dCs.append(float(data[j][2]))
	lc.append(float(data[j][3]))
	dlc.append(float(data[j][4]))
	
plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Tama\~{n}o de comunidad promedio en AVN del modelo de Ising')
plt.ylabel(r'$\langle N_c(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Kn)
plt.errorbar(T,Cs,yerr=dCs,c='k')
plt.show()

plt.axvspan(2.20,2.34, facecolor='k', alpha=0.2)
plt.title('Promedio de longitud de c\'digo')
plt.ylabel(r'$\langle L(T) \rangle$')
plt.xlabel('$T$')
#plt.plot(arange(1.42,3.17,.05),Cn)
plt.errorbar(T,lc,yerr=dlc,c='k')
plt.show()
