
from numpy import *
import random
import matplotlib.pyplot as plt
import math
import networkx as nx
#Desviacion estandar 
def desvi(lista,prom):
	z=0.
		
	for j in range(len(lista)):
		z=z+(lista[j]-prom)**2
	
	return (z/float(len(lista)*(len(lista)-1.)))**.5

	



#Iguala dominio de histogramas
def igualdimDP(K,P):
	mAx=int(max(max(s) for s in K))
	mIn=int(min(min(s)for s in K))
	k=range(mIn,mAx+1)
	PP=[]
	for i in range(len(P)):
		PP.append([0]*len(k))
	for i in k:
		for j in range(len(P)):
			if i in K[j]:
				PP[j][i-mIn]=P[j][K[j].index(i)]
	return k, PP
		
#Distribucion de grado
def hgrado(grados):
	k,ng=[],[]
	for i in grados:
		if i not in k:
			k.append(float(i))
	i=0
	while (i<len(k)-1):
		if (i<len(k)):
			ng.append(grados.index(k[i+1])-grados.index(k[i]))
		i=i+1	

	ng.append(len(grados)-grados.index(k[-1]))	
	return k, list(array(ng)*(1./float(len(grados))))

##Crea la red de visibilidad horizontal
def vishor(t,M):
	G=nx.Graph()
	G.add_nodes_from(t)
	for i in range(0,len(M)-1):
		G.add_edge(i,i+1)
	for i in range(0,len(M)-2):
		j=i+1 
		while (M[j] <M[i] ) and (j<len(M)-1): 
			j=j+1
			Mmax=max(M[i+1:j])
			if (M[j]>Mmax):
				G.add_edge(i,j)
		G.add_edge(i,j)
		if (max(M[i:j])>M[j]):
			G.remove_edge(i,j)
	G.remove_node(len(M)-1)
	return G

#Crea la red de visibilidad natural
def visnat(t,M):
	G=nx.Graph()
	G.add_nodes_from(t)
	for i in range(0,len(M)-1):
		G.add_edge(i,i+1)
	for i in range(0,len(M)-2):
		pm=p=(M[i]-M[i+1])/(t[i]-t[i+1])
		for j in range(i+2,len(M)):
			p=(M[i]-M[j])/(t[i]-t[j])
			if(p>pm):	
				G.add_edge(i,j)		
				pm=p
	return G





#######################################################################
#######################EMPIEZA PROGRAMA################################
#vis.nat

KTn=[]			#grados de los promedios de distribuciones de una temp.
DPTn=[]			#dist. de prob promediada de las series a una temp.
kpromTn=[]		#promedio de grados promedio
CCTn=[]			#promedio de transitivad
ASPLTn=[]		#promedios de aspl  

dKTn=[]			
dDPTn=[]		
dkpromTn=[]		
dCCTn=[]			
dASPLTn=[]
#vis.hor
KTh=[]			#grados de los promedios de distribuciones de una temp.
DPTh=[]			#dist. de prob promediada de las series a una temp.
kpromTh=[]		#promedio de grados promedio
CCTh=[]			#promedio de transitivad
ASPLTh=[]		#promedios de aspl 

dKTh=[]			
dDPTh=[]		
dkpromTh=[]		
dCCTh=[]			
dASPLTh=[]

archin=open('ising-dgnat.txt','w')
archin=open('ising-dgnat.txt','a')

archih=open('ising-dghor.txt','w')
archih=open('ising-dghor.txt','a')



for T in range(142,317,5):
	print T
#vis.nat
	DPn=[]                  #Dist. de Prob de cada serie nat
	KPn=[]			#Grado de cada serie nat
	kpromn=[]               #grado promedio de cada serie
	ASPLn=[]		#aspl de cada serie nat
	CCn=[]                  #transitividad de cada serie nat
	#DPTn=[]		
#vis.hor
	DPh=[]                  #Dist. de Prob de cada serie nat
	KPh=[]			#Grado de cada serie nat
	kpromh=[]               #grado promedio de cada serie
	ASPLh=[]		#aspl de cada serie nat
	CCh=[]                  #transitividad de cada serie nat
	DPTh=[]		
#vis.hor.dir

	#####################
	
	KTh=[]			#grados de los promedios de distribuciones de una temp.

	KTn=[]			#grados de los promedios de distribuciones de una temp.
	DPTn=[]	


	for ite in range(100):
		print ite 

		M=[]
		t=[]
		s='\1 '
		[x for x in s.split('\n')]
		with open(str(T)+'_'+str(ite)+'.txt','r') as f:
		 	data=[x.strip().split('\t') for x in f]
		for j in range(999,len(data)):	
			ti=float(data[j][0])-999
			t.append(ti)
			M.append(float(data[j][1]))
				#Natural
		Gn=visnat(t,M)
		gradosn=sorted(nx.degree(Gn).values())

		Knat,Pnat=hgrado(gradosn)
		DPn.append(Pnat)
		KPn.append(Knat)
		#Horizontal"""
		Gh=vishor(t,M)
		gradosh=sorted(nx.degree(Gh).values())


		Khor,Phor=hgrado(gradosh)
		DPh.append(Phor)
		KPh.append(Khor)



	
	Kh,Ph=igualdimDP(KPh,DPh)
	Kn,Pn=igualdimDP(KPn,DPn)

	for i in range(len(Kh)):
		kt=0
		for j in range(len(Ph)):
			kt=kt+Ph[j][i]
		DPTh.append(kt/float(len(Ph)))
	KTh=Kh

	for i in range(len(Kn)):
		kt=0.              
		for j in range(len(Pn)): ##100
			kt=kt+Pn[j][i]
		
		DPTn.append(kt/float(len(Pn)))
	KTn=Kn


	if KTn[0]==1:
		KTn.pop(0)
		DPTn.pop(0)
	if KTh[0]==1:
		KTh.pop(0)
		DPTh.pop(0)
	
	
	archi1=open('ising-dgnat.txt','a')
	archi1.write(str(T/100.)+"\n") 
	for i in range(len(KTn)):
		archi1.write(str(KTn[i])+"\t")
	archi1.write('\n')
	for i in range(len(KTn)):
		archi1.write(str(DPTn[i])+"\t")
 	archi1.write('\n')
   	#
	archi2=open('ising-dghor.txt','a')
	archi2.write(str(T/100.)+"\n") 
	for i in range(len(KTh)):
		archi2.write(str(KTh[i])+"\t")
	archi2.write('\n')
	for i in range(len(KTh)):
		archi2.write(str(DPTh[i])+"\t")
 	archi2.write('\n')
	
###Distribuciones de grado



archi1.close
archi2.close



